'SE_BookmarkLine.csc
'Copyright 2003 by Abe Hendin <venturadev@yourspeed.com>. All rights reserved.
'Version 1.02, April 15, 2003
'
'Simple script to bookmark the current line for later return with my
'SE_GotoBookmark script. I've got this one on ALT-B, the other on ALT-G.
'
'NOTES:
'The script looks for a line that contains just the script filename 
'*with extension*, as it appears in the first line of this script, within 
'the first 5 lines of the script. It is able to strip the following comment 
'formats: "REM ", "' ", "'", and trailing spaces.
'Unpredictable results may occur with other formats.
'
'The script does not make any changes to your script unless you are prompted 
'to provide a filename, in which case it adds a line with information
'you supply so as to be able to store a "bini" file on your disk. This file 
'is stored in the Graphics8\CONFIG folder, as returned from the registry.
'I made the init file extension "bini" to make it easy to delete old bookmark 
'files if/when you decide to clean out your CONFIG folder.

WITHOBJECT "CorelScript.Automation.8"
	DECLARE SUB ExtractFilename
	DECLARE SUB CreateNewFilenameLine
	DECLARE SUB CreateIniFile
	
	#include "ScpConst.csi"
	GLOBAL i AS INTEGER, iretval AS INTEGER
	GLOBAL sLoseREM AS STRING, sFilename AS STRING
	GLOBAL bCancel AS BOOLEAN
	GLOBAL CurrLineNum AS LONG
	
	CurrLineNum = .GetLineNumber() + 1 'starts with 0 (first line = 0), apparent bug
	sFilename = ""
	
	CALL ExtractFilename

	IF LEN(sLoseREM) > 4 THEN
		sFilename = LEFT(sLoseREM, LEN(sLoseREM) - 4) 'drop extension to get filename
		CALL CreateIniFile
		.GotoLine CurrLineNum 'return to starting point
	ELSEIF LEN(sLoseREM) <= 4 THEN
		iretval = MESSAGEBOX("Cannot find bookmark filename. Would " + \\
			CHR(13) + "you like to create a new entry? ", \\
			"Cannot extract filename", MB_EXCLAMATION_ICON + MB_YES_NO)					
		IF iretval = 6 THEN 'yes
			CALL CreateNewFilenameLine
			IF NOT bCancel THEN
				sFilename = LEFT(sLoseREM, LEN(sLoseREM) - 4) 'drop extension to get filename
				CALL CreateIniFile
				.GotoLine CurrLineNum 'return to starting point
			ELSE
				.GotoLine CurrLineNum 'return to starting point
				MESSAGE "Bookmark not created. "
			ENDIF
		ELSE
			.GotoLine CurrLineNum 'return to starting point
			MESSAGE "Bookmark not created. "
		ENDIF
	ENDIF
	
SUB ExtractFilename
	DIM sLine AS STRING
	sLoseREM = ""
	i = 1
	.GotoLine i
	DO
		sLine = RTRIM(.GetLineText())
		IF RIGHT(sLine, 4) = ".csc" THEN
			IF LEFT(sLine, 2) = "' " THEN
				sLoseREM = LTRIM(RIGHT(sLine, LEN(sLine) - 2))
				EXIT DO
			ELSEIF LEFT(sLine, 1) = "'" THEN
				sLoseREM = LTRIM(RIGHT(sLine, LEN(sLine) - 1))
				EXIT DO
			ELSEIF LEFT(sLine, 4) = "REM " THEN
				sLoseREM = LTRIM(RIGHT(sLine, LEN(sLine) - 4))
				EXIT DO
			ELSE
				EXIT DO
			ENDIF
		ELSE
			i = i + 1
			.GotoLine i
		ENDIF
	LOOP UNTIL i > 5
END SUB

SUB CreateNewFilenameLine
	DIM sLineNum AS STRING, bDone AS BOOLEAN, sLineToAdd AS STRING
	
	bDone = FALSE
	bCancel = FALSE
	WHILE NOT bDone AND NOT bCancel 'get filename
		sFilename = INPUTBOX("Enter the filename. Do NOT append " + \\
			CHR(34) + ".csc" + CHR(34) + ".")
		IF sFilename = "" THEN
			iretval = MESSAGEBOX("Do you want to cancel?", \\
				"Invalid filename", \\
				MB_EXCLAMATION_ICON + MB_YES_NO)
			IF iretval = 6 THEN
				.GotoLine CurrLineNum 'return to starting point
				bCancel = TRUE
			ENDIF
		ELSE
			bDone = TRUE
		ENDIF
	WEND
	
	sLineNum = "0"
	bDone = FALSE
	WHILE NOT bDone AND NOT bCancel 'get line number
		sLineNum = INPUTBOX("Enter the line number at which the " + \\
			"filename should be entered (1-5):")
		IF sLineNum = "" THEN sLineNum = "0"
		IF INT(sLineNum) < 1 OR INT(sLineNum) > 5 THEN
			iretval = MESSAGEBOX("Invalid line number. Do you want to cancel?", \\
				"Invalid line number", \\
				MB_EXCLAMATION_ICON + MB_YES_NO)
			IF iretval = 6 THEN
				.GotoLine CurrLineNum 'return to starting point
				bCancel = TRUE
			ENDIF
		ELSE
			bDone = TRUE
		ENDIF
	WEND
	
	IF NOT bCancel THEN
		sLineToAdd = "'" + LTRIM(RTRIM(sFilename)) + ".csc"
		.GotoLine sLineNum
		.AddLineBefore(sLineToAdd)
		CurrLineNum = CurrLineNum + 1
		sLoseREM = RIGHT(sLineToAdd, LEN(sLineToAdd) - 1)
	ENDIF
END SUB

SUB CreateIniFile
	DIM sConfigDir AS STRING
	sConfigDir = REGISTRYQUERY(2, "SOFTWARE\Corel\Corel Ventura\8.0", "ConfigDir")
	SETCURRFOLDER sConfigDir
	OPEN sConfigDir + "\" + sFilename + ".bini" FOR OUTPUT AS #1
	PRINT #1, CurrLineNum
	CLOSE #1
END SUB

END WITHOBJECT

