'SE_GotoBookmark.csc
'Copyright 2003 by Abe Hendin <venturadev@yourspeed.com>. Public Domain.
'Version 1.03, May 4, 2003
'
'Simple script to return to a line bookmarked with my SE_BookmarkLine
'script. I've got this one on ALT-G, the other on ALT-B.
'
'Version 1.03 corrects a bug whereby .GotoLine fails if text is selected.

WITHOBJECT "CorelScript.Automation.8"
	DECLARE SUB ExtractFilename
	
	#include "ScpConst.csi"
	GLOBAL sLoseREM AS STRING, sFilename AS STRING
	DIM iretval AS INTEGER
	DIM CurrLineNum AS LONG
	DIM sBookmarkLine AS STRING
	DIM sConfigDir AS STRING, sTest AS STRING

	sFilename = ""
	CurrLineNum = .GetLineNumber() + 1 'starts with 0 (first line = 0), apparent bug
	
	'the following lines correct for a bug where .GotoLine fails if text is selected;
	'DO NOT MOVE! Another bug leads to a content line being deleted if it follows 
	'reading the bini file where the bookmarked line number is stored.
	.AddLineBefore ""
	.GotoLine CurrLineNum
	.DeleteLine
	'END BUG CORRECTION
	
	sFilename = ""
	
	CALL ExtractFilename
	
	IF LEN(sLoseREM) > 4 THEN
		sFilename = LEFT(sLoseREM, LEN(sLoseREM) - 4) 'drop extension to get filename
	
		'read ini file
		sConfigDir = REGISTRYQUERY(2, "SOFTWARE\Corel\Corel Ventura\8.0", "ConfigDir")
		SETCURRFOLDER sConfigDir
		ON ERROR RESUME NEXT
		OPEN sConfigDir + "\" + sFilename + ".bini" FOR INPUT AS #1
		IF ERRNUM = 201 THEN
			.GotoLine CurrLineNum 'return to starting point
			iretval = MESSAGEBOX("Bookmark file does not exist. Please run " + \\
				CHR(13) + "SE_BookmarkLine.csc to recreate.", "Missing bookmark file", \\
				MB_EXCLAMATION_ICON + MB_OK_ONLY)
		ELSE
			LINE INPUT #1, sBookmarkLine
			CLOSE #1
			
			.GotoLine sBookmarkLine
		ENDIF
	ELSEIF LEN(sLoseREM) <= 4 THEN
		.GotoLine CurrLineNum 'return to starting point
		iretval = MESSAGEBOX("Cannot find a bookmark filename. Please " + \\
			CHR(13) + "run SE_BookmarkLine.csc to reset. ", \\
			"Cannot find bookmark filename", MB_EXCLAMATION_ICON + MB_OK_ONLY)
	ENDIF
	
SUB ExtractFilename
	DIM i AS INTEGER, sLine AS STRING
	sLoseREM = ""
	i = 1
	.GotoLine i
	DO
		sLine = RTRIM(.GetLineText())
		IF RIGHT(sLine, 4) = ".csc" THEN
			IF LEFT(sLine, 2) = "' " THEN
				sLoseREM = LTRIM(RIGHT(sLine, LEN(sLine) - 2))
				EXIT DO
			ELSEIF LEFT(sLine, 1) = "'" THEN
				sLoseREM = LTRIM(RIGHT(sLine, LEN(sLine) - 1))
				EXIT DO
			ELSEIF LEFT(sLine, 4) = "REM " THEN
				sLoseREM = LTRIM(RIGHT(sLine, LEN(sLine) - 4))
				EXIT DO
			ELSE
				EXIT DO
			ENDIF
		ELSE
			i = i + 1
			.GotoLine i
		ENDIF
	LOOP UNTIL i > 5
END SUB
END WITHOBJECT

